package com.perfectech.tis.activities;

import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageInfo;
import android.content.pm.PackageManager;
import android.graphics.Color;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.support.v7.app.AlertDialog;
import android.support.v7.app.AppCompatActivity;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.webkit.WebView;
import android.widget.Button;
import android.widget.TextView;
import android.widget.ImageView;
import android.util.Log;

import com.perfectech.tis.DBLogs;
import com.perfectech.tis.DBParameters;
import com.perfectech.tis.R;
import com.perfectech.tis.syncClasses.SyncImporter;
import com.perfectech.tis.syncClasses.SyncJobs;
import com.perfectech.tis.syncClasses.SyncMessages;
import com.perfectech.tis.syncClasses.SyncUsers;
import com.perfectech.tis.syncClasses.TISCommon;
import com.perfectech.tis.webServices.SyncFiles;
import com.perfectech.tis.webServices.SyncJson;

import java.io.File;

public class StartupActivity extends AppCompatActivity {

    private static final String sDBName = "TIS.db";
    private static final int iVersionVal = 7;
    private static String sUserID = "";
    private ProgressDialog progress = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        setContentView(R.layout.activity_startup);

        SharedPreferences prefs = getSharedPreferences("TISSharedPrefs",
                Context.MODE_PRIVATE);
        SharedPreferences.Editor editor = prefs.edit();
        String sLoggedInUserCompany = prefs.getString("LoggedInUserCompany", "No Value");
        sUserID = prefs.getString("UserID", "No Value");
        TextView otvUserName = (TextView) findViewById(R.id.tvUserName);
        otvUserName.setText(sLoggedInUserCompany.substring(0,sLoggedInUserCompany.indexOf('-')));

        WebView wvNotice = (WebView) findViewById(R.id.wvNotice);
        //wvNotice.loadDataWithBaseURL("file:///android_asset/",htmlData, "text/html", "UTF-8", null);
        wvNotice.loadUrl("file:///android_asset/TISNotice.htm");

        Button btnJobsCenter = (Button) findViewById(R.id.btnComplete);
        btnJobsCenter.setVisibility(View.INVISIBLE);
        btnJobsCenter.setOnClickListener(new View.OnClickListener() {
            public void onClick(View v) {
                finish();
                Intent i = new Intent(getApplicationContext(), MainActivity.class);
                startActivity(i);
            }
        });
    }

    @Override
    protected void onResume() {
        super.onResume();
        // Always make sure debug mode is set back to false on login
        DBParameters oDBParameters = new DBParameters();
        try {
            oDBParameters.updateParameter("DebugMode",
                    "0", getApplicationContext(), sDBName,
                    iVersionVal);
        } catch (Exception ex) {
            // To do
        }
            syncAll();
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_startup, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        if (id == R.id.action_logout) {
            finish();
            Intent i = new Intent(getApplicationContext(), TISActivity.class);
            startActivity(i);
            return true;
        }
        if (id == R.id.action_about) {
            Intent i = new Intent(getApplicationContext(), AboutActivity.class);
            startActivity(i);
            return true;
        }
        return super.onOptionsItemSelected(item);
    }

    /**********************************************************************************/
    /* This method will sync the data from the server                                 */
    /**********************************************************************************/
    private void syncAll() {
        TextView oTask1 = (TextView) findViewById(R.id.tvtask1);
        ImageView oCheckMark1 = (ImageView) findViewById(R.id.ivChkMk1);
        TextView oTask2 = (TextView) findViewById(R.id.tvtask2);
        ImageView oCheckMark2 = (ImageView) findViewById(R.id.ivChkMk2);
        TextView oTask3 = (TextView) findViewById(R.id.tvtask3);
        ImageView oCheckMark3 = (ImageView) findViewById(R.id.ivChkMk3);
        TextView oTask4 = (TextView) findViewById(R.id.tvtask4);
        ImageView oCheckMark4 = (ImageView) findViewById(R.id.ivChkMk4);
        TextView oTask5 = (TextView) findViewById(R.id.tvtask5);
        ImageView oCheckMark5 = (ImageView) findViewById(R.id.ivChkMk5);
        TextView oTask6 = (TextView) findViewById(R.id.tvtask6);
        ImageView oCheckMark6 = (ImageView) findViewById(R.id.ivChkMk6);
        Button btnJobsCenter = (Button) findViewById(R.id.btnComplete);

        //Moved all of the login checks into a background process
        syncStuff();

        // task1 -- software check
        oTask1.setTextColor(Color.WHITE);
        oCheckMark1.setVisibility(View.VISIBLE);
        oTask1.invalidate();

        oTask1.setTextColor(Color.GREEN);
        oCheckMark1.invalidate();
        oTask1.invalidate();

        // task2 -- importer sync
        oTask2.setTextColor(Color.WHITE);
        oTask2.invalidate();

        oCheckMark2.setVisibility(View.VISIBLE);
        oTask2.setTextColor(Color.GREEN);
        oCheckMark2.invalidate();
        oTask2.invalidate();

        // task3 -- operator sync
        oTask3.setTextColor(Color.WHITE);
        oTask3.invalidate();

        oCheckMark3.setVisibility(View.VISIBLE);
        oTask3.setTextColor(Color.GREEN);
        oCheckMark3.invalidate();
        oTask3.invalidate();

        // task4 -- message sync
        oTask4.setTextColor(Color.WHITE);
        oTask4.invalidate();

        oCheckMark4.setVisibility(View.VISIBLE);
        oTask4.setTextColor(Color.GREEN);
        oCheckMark4.invalidate();
        oTask4.invalidate();

        // task5 -- jobs sync
        oTask5.setTextColor(Color.WHITE);
        oTask5.invalidate();

        oCheckMark5.setVisibility(View.VISIBLE);
        oTask5.setTextColor(Color.GREEN);
        oCheckMark5.invalidate();
        oTask5.invalidate();

        // task6 -- user sync
        oTask6.setTextColor(Color.WHITE);
        oTask6.invalidate();

        oCheckMark6.setVisibility(View.VISIBLE);
        oTask6.setTextColor(Color.GREEN);
        oCheckMark6.invalidate();
        oTask6.invalidate();

        // turn button on when all sync processing has completed
        btnJobsCenter.setVisibility(View.VISIBLE);
        if (TISCommon.isOnline(getApplicationContext())) {
            //Only do this if we are online
            getVersion(getApplicationContext());
        }
    }

    //This thread will take care of downloading everything so that the initial sign in is faster
    private void syncStuff() {
        new Thread(new Runnable() {
            @Override
            public void run() {
                Context oContext = getApplicationContext();
                try {
                    TISCommon.cleanSyncTable(oContext);
                    TISCommon.cleanDVIRTable(oContext);
                    TISCommon.cleanJobsTable(oContext);
                } catch (Exception ex) {
                    DBLogs.insert("Clean Tables Error: " + ex.toString(),
                            "StartupActivity.syncStuff.TISCommon", oContext,
                            sDBName, iVersionVal);
                }

                if (TISCommon.isOnline(oContext)) {
                    try {
                        TISCommon.updateParameters(oContext);
                    } catch (Exception ex) {
                        DBLogs.insert("Clean Tables Error: " + ex.toString(),
                                "StartupActivity.syncStuff.TISCommon(1)", oContext,
                                sDBName, iVersionVal);
                    }
                    try {
                        SyncImporter.sUserName = sUserID;
                        SyncImporter.oContext = oContext;
                        SyncImporter.getImporters();
                    } catch (Exception ex) {
                        Log.e("SyncImporter Error:", ex.toString());
                        DBLogs.insert("SyncImporter Error: " + ex.toString(),
                                "StartupActivity.syncStuff.syncImporters", oContext,
                                sDBName, iVersionVal);
                    }
                    try {
                        SyncMessages.sUserName = sUserID;
                        SyncMessages.oContext = oContext;
                        SyncMessages.getMessages();
                    } catch (Exception ex) {
                        Log.e("SyncMessages Error:", ex.toString());
                        DBLogs.insert("SyncMessages Error: " + ex.toString(),
                                "StartupActivity.syncStuff.SyncMessages", oContext,
                                sDBName, iVersionVal);
                    }
                    try {
                        SyncJobs.sUserName = sUserID;
                        SyncJobs.oContext = oContext;
                        SyncJobs.getJobs();
                        SyncJobs.getJobStatusType();
                        SyncJobs.getgpscoords();
                    } catch (Exception ex) {
                        Log.e("SyncJobs Error:", ex.toString());
                        DBLogs.insert("SyncJobs Error: " + ex.toString(),
                                "StartupActivity.syncStuff.SyncJobs", oContext,
                                sDBName, iVersionVal);
                    }
                    try {
                        SyncUsers.oContext = oContext;
                        SyncUsers.sUserName = sUserID;
                        SyncUsers.getUsers();
                    } catch (Exception ex) {
                        Log.e("SyncUsers Error:", ex.toString());
                        DBLogs.insert("SyncUsers Error: " + ex.toString(),
                                "StartupActivity.syncStuff.SyncUsers", oContext,
                                sDBName, iVersionVal);
                    }
                    try {
                        SyncUsers.oContext = oContext;
                        SyncUsers.sUserName = sUserID;
                        SyncUsers.refreshProfile();
                    } catch (Exception ex) {
                        Log.e("SyncUsers Error:", ex.toString());
                        DBLogs.insert("SyncUsers Error: " + ex.toString(),
                                "StartupActivity.syncStuff.SyncUsers", oContext,
                                sDBName, iVersionVal);
                    }
                }
            }
        }).start();
    }

    public void getVersion(Context context) {
        try {
            SyncJson chkVersion = new SyncJson();
            chkVersion.oContext = getApplication();
            chkVersion.sendString = "";
            chkVersion.webserviceName = "currentVersion.php";
            String sNewVersion = chkVersion.SyncData();
            PackageInfo pInfo = context.getPackageManager().getPackageInfo(
                    context.getPackageName(), PackageManager.GET_META_DATA);
            String sCurrentVersion = pInfo.versionName.toString();
            if (!sNewVersion.equals(sCurrentVersion)) {
                TextView title = new TextView(this);
                title.setText(getResources().getString(R.string.new_version_available_title));
                title.setBackgroundColor(getResources().getColor(R.color.TISPurple));
                title.setPadding(10, 10, 10, 10);
                title.setGravity(Gravity.CENTER);
                title.setTextColor(Color.WHITE);
                title.setTextSize(20);
                new AlertDialog.Builder(this)
                        .setCustomTitle(title)
                        .setMessage(getResources().getString(R.string.new_version_available_text))
                        .setPositiveButton(getResources().getString(R.string.new_version_available_ok), new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                //Download the apk
                                dialog.dismiss();
                                downloadAndInstall();
                            }
                        })
                        .setNegativeButton(getResources().getString(R.string.new_version_available_cancel), new DialogInterface.OnClickListener() {
                            public void onClick(DialogInterface dialog, int which) {
                                // close dialog and exit the app
                                dialog.dismiss();
                            }
                        })
                        .show();
            }
        } catch (PackageManager.NameNotFoundException e) {
            //todo
        }
    }

    private boolean storageDirExists(File storageDir) {
        Boolean bRtnValue = true;
        if (!storageDir.exists()) {
            bRtnValue = storageDir.mkdir();
        }
        return bRtnValue;
    }

    private void downloadAndInstall() {
        File storageDir = new File(Environment.getExternalStorageDirectory() + "/tis");
        if (storageDirExists(storageDir)) {
            //run the download thread
            progress = new ProgressDialog(this);
            progress.setTitle("Downloading");
            progress.setMessage("Wait while downloading...");
            progress.show();
            downloadThread download = new downloadThread();
            download.start();
        }
    }

    private class downloadThread extends Thread {

        @Override
        public void run() {
            DBParameters oDBParameters = new DBParameters();
            String sSoftwareUpdateURL = oDBParameters.readParameter(
                    "SoftwareUpdateURL", getApplicationContext(), sDBName, iVersionVal);
            String sSoftwareUpdateName = oDBParameters.readParameter(
                    "SoftwareName", getApplicationContext(), sDBName, iVersionVal);
            File storageDir = new File(Environment.getExternalStorageDirectory() + "/tis");
            try {
                SyncFiles.oContext = getApplicationContext();
                SyncFiles.fFilePath = storageDir;
                SyncFiles.sFileName = sSoftwareUpdateName;
                SyncFiles.sWebService = sSoftwareUpdateURL + sSoftwareUpdateName;
                SyncFiles.downloadFile();
            } catch (Exception ex) {

            }
            handler.sendEmptyMessage(0);
        }

        protected Handler handler = new Handler() {

            @Override
            public void handleMessage(Message msg) {
                progress.dismiss();
                DBParameters oDBParameters = new DBParameters();
                String sSoftwareUpdateURL = oDBParameters.readParameter(
                        "SoftwareUpdateURL", getApplicationContext(), sDBName, iVersionVal);
                String sSoftwareUpdateName = oDBParameters.readParameter(
                        "SoftwareName", getApplicationContext(), sDBName, iVersionVal);
                Intent intent = new Intent(Intent.ACTION_VIEW);
                intent.setDataAndType(Uri.fromFile(new File(Environment.getExternalStorageDirectory() + "/tis/" + sSoftwareUpdateName)), "application/vnd.android.package-archive");
                intent.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                startActivity(intent);
            }
        };
    }
}
